=== RT288x_SDK/source/user/openl2tp-1.6/debian/changelog ===
openl2tp (1.6-1) unstable; urgency=low

  * Import a patch from Ben McKeegan which ensures that subprocesses
    don't inherit opened file descriptors from openl2tpd. In some
    circumstances, sockets would remain open until all spawned
    processes exited, which lead to some unusual
    effects. Specifically, for any given tunnel, so long as any of the
    pppd processes that were forked while that tunnel was up
    (including those on different tunnels) are still running or any
    daemons started from their init scripts are running, the UDP
    socket is never closed, even when openl2tp itself has long since
    closed the socket and forgotten about it. This also fixes Bug
    #2056243 reported by Ulrich Holeschak.

  * Deprecate the l2tpconfig help command. The help command caused
    l2tpconfig to hang but since it doesn't add any value over the man
    page, let's deprecate it. This was first reported in Bug #1792299.

  * Fix compiler warnings in the pppd plugins.

  * Avoid linking openl2tpd/l2tpconfig against unnecessary libs
    (libnsl, libncurses, librt).

  * Split the RPC and header files out to a separate devel package;
    these files only need to be installed by developers implementing
    OpenL2TP plugins or applications that use the OpenL2TP APIs.

  * Fix a bug that was introduced in v1.5 which broke the
    inhibit_default_plugin flag. This flag is used by some test
    plugins to inhibit the use of ppp_unix.so for testing.

 -- James Chapman <jchapman@katalix.com>  Wed, 24 Sep 2008 21:53:23 +0000

openl2tp (1.5-1) unstable; urgency=low

  * Fix ppp profile ppp authentication options which seem to have been
    broken since 0.17. The auth_pap, auth_chap etc options should
    translate into refuse-xxx options to pppd, but these pppd
    arguments were not generated properly.

  * While testing an install for an ISP, it was found that pppd would
    always offer EAP authentication when negotiating with its peer,
    despite auth_eap=off being set in the ppp profile. It turns out
    that some ppp peers (including Cisco!) drop the connection unless
    the peer asks for the exactly the same authentication
    method. Specifically, in a Cisco, if CHAP is configured, it will
    drop the connection if the peer suggests that it can do EAP. To
    configure pppd to force a specific authentication method, one of
    pppd's require-xxx options must be used. Until now, OpenL2TP has
    no interface to control pppd's require-xxx auth options. With this
    release, if all but one of the ppp profile's auth_xxx options is
    disabled, OpenL2TP will now automatically add the require-xxx pppd
    auth option for the one auth option that is enabled. For example,
    to configure CHAP only, set auth_chap=yes auth_pap=no
    auth_mschapv1=no auth_mschapv2=no auth_eap=no in the ppp
    profile. This will yield the following pppd arguments: refuse-pap
    refuse-mschap refuse-mschap-v2 refuse-eap require-chap.

  * Fixed a bug in the per-tunnel session limit handling. If
    configured with a session limit (non-zero max_sessions value), the
    tunnel's session count would be decremented twice if a session was
    cleaned up as a result of reaching the session limit. As a result,
    the next session would be successfully created, resulting in more
    sessions on the tunnel than the user requested.

  * Improve session event generation such that session_down events are
    generated only if the session_up event was previously generated
    and session_deleted events are generated only if the
    session_created event was previously generated. Previously, if a
    session never came up successfully, a session_down and a
    session_deleted event was generated. Anyone using custom openl2tp
    plugins which use the session_down and session_deleted hooks
    should test their plugins after taking this release.

  * Add a new event_sock plugin which exports a named pipe
    /tmp/openl2tpd.evt for use by other processes. A process may
    listen on the named pipe for event messages from openl2tpd which
    tell of session up/down/created/deleted events. See
    doc/README.event_sock for details.

  * Change the loading of plugins to be done after the core
    application init has completed. In previous versions, plugins were
    loaded during command line argument parsing. This change allows
    plugins to use openl2tpd internal APIs that would otherwise be
    uninintalialised when the plugin is loaded. The new event_sock
    plugin makes use of this to register its file descriptor(s) with
    the application main loop.

 -- James Chapman <jchapman@katalix.com>  Sun, 17 Aug 2008 10:22:41 +0000

openl2tp (1.4-1) unstable; urgency=low

  * Fix a bug in the parsing of some parameters of config
    files. Previous versions limited the characters that could be used
    in string values such that parameters that were filenames
    containing the / character lead to parse errors. The parser is now
    more flexible about the characters that it allows in string
    values.

  * Revert a change made in 1.0 to do with L2TP Hello message
    generation. Prior to 1.0, we only sent Hello packets if no L2TP
    control _or_ data packets passed over the tunnel during the Hello
    timeout period, but this was changed to unconditionally send
    Hellos. It turns out that the L2TPv3 spec (Openl2tp is currently
    L2TPv2) specifies the behaviour that we had prior to 1.0. The new
    spec says that the L2TPv2 spec was misinterpreted by several
    vendors and explicitely calls out that all L2TP implementations
    should check for both control and data activity before sending a
    Hello. This avoids possible Hello timeouts when under extreme load
    conditions, where Hello messages might be swamped by data traffic.

  * Don't create the tunnel PPPoX socket until the tunnel is
    up. (Session PPPoX sockets are unchanged.) We previously created

